 ;==============================================================;
;|~~~~~~~~~~~~~~~~~~~~~~++==============++~~~~~~~~~~~~~~~~~~~~~~|;
;|			||    GSE.inc   ||			|;
;|~~~~~~~~~~~~~~~~~~~~~~++==============++~~~~~~~~~~~~~~~~~~~~~~|;
;|	include file written by Lord Henry !!!			|;
;|never forget to include ti83plus.inc as well !!!		|;
;|this file only give you what 's needed for developping GSE	|;
;|apps or programs						|;
;|______________________________________________________________|;
 ;==============================================================;

;valid versions value for loading
;a wierd system but small and powerful :  - first nibble is major version
;					  - second one is minor version


GSE.beta7	=	$07
;GSE.realease1	=	$10

;constant used for version check during the loading

_GSE_		=	$00


 ;=============================================================;
;				Flags	 			;
 ;=============================================================;

; wierd again, at least for those who never coded C++ with windows
; API, others, like me, will find it logic and simple.
; you just have to separate flags by a :  |
; yes it's the TASM OR bitwise !!!


 ;=============================================================;
;			General Variables			;
 ;=============================================================;

; beware they're read-only (or you'll get some crash)
; especially from "GSE.codingRAM" to "GSE.FlashPage"

GSE.Buf1	=	plotsscreen		;backbuffer 1 ==> 768 bytes
GSE.Buf2	=	appbackupscreen		;backbuffer 2 ==> 768 bytes


GSE.Buf1addr		=	$8000		;2 bytes
GSE.Buf2addr		=	$8002		;2 bytes
GSE.ActBuf1addr		=	$8004		;2 bytes
GSE.ActBuf2addr		=	$8006		;2 bytes
GSE.ActBuf1addrS	=	$8008		;2 bytes
GSE.ActBuf2addrS	=	$800A		;2 bytes
GSE.PutSaddr		=	$800C		;2 bytes
GSE.IsoBuf		=	$800E		;2 bytes
GSE.sav_sprt		=	$8010		;2 bytes
GSE.compt		=	$8012		;1 byte
GSE.KeyMem		=	$8013		;1 byte
GSE.BitKey.Mem		=	$8014		;7 bytes
GSE.TempSprite		=	$801B		;16 bytes
GSE.TempSprite2		=	$802B		;16 bytes
GSE.codingRAM		=	$803B		;36 bytes
GSE.FlashPage		=	$805F		;1 byte


 ;=============================================================;
;		macros used to access GSEngine functions	;
 ;=============================================================;

#ifdef _GSE.APP_		; <ZDS>

gse_call macro	label
	call	GSE.codingRAM
	DW	&label
	.endm
				; </ZDS>
#else
				; <TASM>
#define	gseCall(label)	call GSE.codingRAM \ .dw label

#endif				; </TASM>

 ;=============================================================;
;			some useful macros			;
 ;=============================================================;

#define	GSE.SetMinVer(version)	_GSE_	.set	version
#define	GSE.Version(version)	_GSE_	.set	version

; I'm so nice that I give you these interesting macros that reveal a
; powerful check mechanism

; all of them destroy a

#define	is_16b_0(r8,r8_2)	ld a, r8 \ OR r8_2
#define	is_24b_0(r8,r8_2,r8_3)	is_16b_0(r8,r8_2) \ OR r8_3
#define	is_32b_0(r8,r8_2,r8_3,r8_4)	is_24b_0(r8,r8_2,r8_3) \ OR r8_4

 ;=============================================================;
;		KeyGroup equates of GetBitKey			;
 ;=============================================================;
;
; index register offset
;	ex:	bit	DI_MODE, (ix + KI_TOP)
;
KI_1		=	5
KI_2		=	4
KI_3		=	3
KI_4		=	2
KI_5		=	1
KI_ARROW	=	0
KI_TOP		=	6

 ;=============================================================;
;			Direct input KeyGroup 			;
 ;=============================================================;
KG_1            = 	$DF		; 1st col
KG_2            = 	$EF		; 2nd col
KG_3            = 	$F7		; 3rd col
KG_4            = 	$FB		; 4th col
KG_5            = 	$FD		; 5th col
KG_ARROW        = 	$FE		; arrows
KG_TOP          = 	$BF		; F1-F4, 2nd, Del, MODE

 ;=============================================================;
;			Direct input BIT codes			;
 ;=============================================================;
DI_Y            = 	4
DI_WINDOW       = 	3
DI_ZOOM         = 	2
DI_TRACE        = 	1
DI_GRAPH        = 	0
DI_2ND          = 	5
DI_MODE         = 	6
DI_DEL          = 	7
DI_UP           = 	3
DI_DOWN         = 	0
DI_LEFT         = 	1
DI_RIGHT        = 	2
DI_ALPHA        = 	7
DI_XTON         = 	7
DI_STAT         = 	7
DI_MATH         = 	6
DI_MATRX        = 	6
DI_PRGM         = 	6
DI_VARS         = 	6
DI_CLEAR        = 	6
DI_SIN          = 	5
DI_COS          = 	5
DI_TAN          = 	5
DI_POWER        = 	5     		; ^
DI_X2           = 	4     		; X^2
DI_COMMA        = 	4     		; ,
DI_LPAR         = 	4     		; (
DI_RPAR         = 	4     		; )
DI_DIV          = 	4     		; /
DI_LOG          = 	3
DI_7            = 	3
DI_8            = 	3
DI_9            = 	3
DI_MUL          = 	3     		; *
DI_LN           = 	2
DI_4            = 	2
DI_5            = 	2
DI_6            = 	2
DI_MINUS        = 	2     		; -
DI_STO          = 	1     		; STO->
DI_1            = 	1
DI_2            = 	1
DI_3            = 	1
DI_PLUS         = 	1     		; +
DI_0            = 	0
DI_DEC          = 	0     		; .
DI_NEG          = 	0     		; (-)
DI_ENTER        = 	0

